/* ---------------------------------------------------------------------- */
/* Install VNC Server and Viewer                                          */
/* Author: F. Hodel A-Net GmbH, www.anetgmbh.ch                           */
/* use at own risk! Please save Your data fist!                           */
/* ---------------------------------------------------------------------- */

/* activate REXX Utils                                                     */

  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  call SysLoadFuncs

 '@echo off'

/* determine source drive for installation (CD or LAN drive)               */

   drivelist=SysDriveMap(,'USED')   /* all local and LAN drives */
   do forever
     parse var drivelist cddrv ' ' drivelist
     cddrv=strip(cddrv)
     filter = stream(cddrv'\cmd\inst_emx.cmd','c','query exists')
     if filter <> '' then  leave
   end /* do forever */
   say 'Quell-Laufwerk ist' cddrv

/* determine boot drive                                                    */
  bootdrv = SysBootDrive()
  say 'Boot-Laufwerk ist ' bootdrv
  say ''

/* ---------------------------------------------------------------------- */
/* Install VNC and VNC-Viewer                                             */
/* ---------------------------------------------------------------------- */

  say ' '
  say 'Ŀ'
  say '       Installationslaufwerk whlen         '
  say ''
  say ' '
  say 'PM VNC Server und Viewer werden nach 'bootdrv||'\A\VNC und 'bootdrv||'\A\PMVNC kopiert'
  say '[Enter] falls o.k.,'
  say 'sonst Laufwerks-Buchstaben angeben:'
  pull answer
  if answer=='' then answer='C'
  if answer<>'' then do
     if substr(answer,length(answer),1) == ':'    /* : am Zeilenende       */
        then dd = ''
        else dd = ':'
     drive=answer||dd
   end /* if answer */

  'xcopy ' cddrv||'\PMVNC\*.* ' drive||'\A\PMVNC'||'\ /s'
  'xcopy ' cddrv||'\VNC\*.* '   drive||'\A\VNC'||'\ /s'

/* ---------------------------------------------------------------------- */
/*  Icon for VNC Viewer                                                   */
/* ---------------------------------------------------------------------- */

/* create Desktop Icon */
       If SysCreateObject("WPProgram","VNC Viewer","<WP_DESKTOP>",,
         "OBJECTID=<VNCVIEW>;"||,
         "EXENAME="drive||"\a\vnc\vncview.exe;"||,
         "STARTUPDIR="drive||"\a\vnc;"||,
         "PROGTYPE=PM;")
       Then Say '" Programm VNC Viewer" erstellt'
       Else Say '"Programm VNC-Viewer" nicht erstellt'
/* Icon created  */

/* ---------------------------------------------------------------------- */
/*  VNC-Server PMVNC installieren                                         */
/* ---------------------------------------------------------------------- */

  drive
  'cd \a\pmvnc'
  'call install.cmd'
  'pause'

ende:
  cddrv
  'cd \'
